//	Visual Clipper Ver 2.0pʃt@C֐
#pragma once

union DWORDBYTE
{
	DWORD dw;
	BYTE b[4];
};

union DWORDWORD
{
	DWORD dw;
	WORD w[2];
};

union WORDBYTE
{
	WORD w;
	BYTE b[2];
};

union XMMDATA
{
	__m128 xf;
	__m128i xi;
	__m128d xd;
	BYTE b[16];
	WORD w[8];
	DWORD dw[4];
	FLOAT f[4];
	DOUBLE d[2];
};

//	ϊs\܂B
//	W(x, y)̈ړ(x', y')ƂƂȉ̎܂B
//	x' = (x * _11 + y * _12 + _13) / (x * _31 + y * _32 + _33)
//	y' = (x * _21 + y * _22 + _23) / (x * _31 + y * _32 + _33)
struct TRANSFORMMATRIX
{
	union
	{
		FLOAT m[3][3];
		struct
		{
			FLOAT _11;
			FLOAT _12;
			FLOAT _13;
			FLOAT _21;
			FLOAT _22;
			FLOAT _23;
			FLOAT _31;
			FLOAT _32;
			FLOAT _33;
		};
	};
	__forceinline FLOAT TransformX(FLOAT x, FLOAT y);
	__forceinline FLOAT TransformY(FLOAT x, FLOAT y);
	__forceinline FLOAT TransformZ(FLOAT x, FLOAT y);
	__forceinline void Transform(FLOAT& px, FLOAT& py);
	__forceinline void Transform(FLOAT& px, FLOAT& py, FLOAT x, FLOAT y);
	__forceinline void TransformInteger(LONG& px, LONG& py);
	__forceinline void TransformInteger(LONG& px, LONG& py, LONG lx, LONG ly);
	__forceinline void SetInverse();
	__forceinline void SetIdentity();
	__forceinline void MultiplyLeft(TRANSFORMMATRIX* pMatrix);
	__forceinline void MultiplyRight(TRANSFORMMATRIX* pMatrix);
};

__forceinline FLOAT TRANSFORMMATRIX::TransformX(FLOAT x, FLOAT y)
{
	return x * _11 + y * _12 + _13;
}

__forceinline FLOAT TRANSFORMMATRIX::TransformY(FLOAT x, FLOAT y)
{
	return x * _21 + y * _22 + _23;
}

__forceinline FLOAT TRANSFORMMATRIX::TransformZ(FLOAT x, FLOAT y)
{
	return x * _31 + y * _32 + _33;
}

__forceinline void TRANSFORMMATRIX::Transform(FLOAT& px, FLOAT& py)
{
	FLOAT x;
	FLOAT y;
	FLOAT z;
	x = px;
	y = py;
	z = TransformZ(x, y);
	px = TransformX(x, y) / z;
	py = TransformY(x, y) / z;
}

__forceinline void TRANSFORMMATRIX::Transform(FLOAT& px, FLOAT& py, FLOAT x, FLOAT y)
{
	FLOAT z;
	z = TransformZ(x, y);
	px = TransformX(x, y) / z;
	py = TransformY(x, y) / z;
}

__forceinline void TRANSFORMMATRIX::TransformInteger(LONG& px, LONG& py)
{
	FLOAT x;
	FLOAT y;
	FLOAT z;
	x = (FLOAT)px;
	y = (FLOAT)py;
	z = TransformZ(x, y);
	px = (LONG)(TransformX(x, y) / z);
	py = (LONG)(TransformY(x, y) / z);
}

__forceinline void TRANSFORMMATRIX::TransformInteger(LONG& px, LONG& py, LONG lx, LONG ly)
{
	FLOAT x;
	FLOAT y;
	FLOAT z;
	x = (FLOAT)lx;
	y = (FLOAT)ly;
	z = TransformZ(x, y);
	px = (LONG)(TransformX(x, y) / z);
	py = (LONG)(TransformY(x, y) / z);
}

__forceinline void TRANSFORMMATRIX::SetInverse()
{
	DWORD i;
	DWORD j;
	DOUBLE d[3][3];
	DOUBLE e;
	e = m[0][0] * m[1][1] * m[2][2] + m[0][1] * m[1][2] * m[2][0] + m[0][2] * m[1][0] * m[2][1] - m[0][0] * m[1][2] * m[2][1] - m[0][1] * m[1][0] * m[2][2] - m[0][2] * m[1][1] * m[2][0];
	d[0][0] = m[1][1] * m[2][2] - m[1][2] * m[2][1];
	d[0][1] = m[0][1] * m[2][2] - m[0][2] * m[2][1];
	d[0][2] = m[0][1] * m[1][2] - m[0][2] * m[1][1];
	d[1][0] = m[1][0] * m[2][2] - m[1][2] * m[2][0];
	d[1][1] = m[0][0] * m[2][2] - m[0][2] * m[2][0];
	d[1][2] = m[0][0] * m[1][2] - m[0][2] * m[1][0];
	d[2][0] = m[1][0] * m[2][1] - m[1][1] * m[2][0];
	d[2][1] = m[0][0] * m[2][1] - m[0][1] * m[2][0];
	d[2][2] = m[0][0] * m[1][1] - m[0][1] * m[1][0];
	for(i = 0; i < 3; i++)
	{
		for(j = 0; j < 3; j++)
		{
			m[i][j] = (FLOAT)(d[i][j] / e);
			if((i + j) % 2 == 1)
				m[i][j] *= -1.0f;
		}
	}
}

__forceinline void TRANSFORMMATRIX::SetIdentity()
{
	_11 = 1.0f;
	_12 = 0.0f;
	_13 = 0.0f;
	_21 = 0.0f;
	_22 = 1.0f;
	_23 = 0.0f;
	_31 = 0.0f;
	_32 = 0.0f;
	_33 = 1.0f;
}

__forceinline void TRANSFORMMATRIX::MultiplyLeft(TRANSFORMMATRIX* pMatrix)
{
	TRANSFORMMATRIX Matrix;
	DWORD i;
	DWORD j;
	Matrix = *this;
	for(i = 0; i < 3; i++)
	{
		for(j = 0; j < 3; j++)
			m[i][j] = pMatrix->m[i][0] * Matrix.m[0][j] + pMatrix->m[i][1] * Matrix.m[1][j] + pMatrix->m[i][2] * Matrix.m[2][j];
	}
}

__forceinline void TRANSFORMMATRIX::MultiplyRight(TRANSFORMMATRIX* pMatrix)
{
	TRANSFORMMATRIX Matrix;
	DWORD i;
	DWORD j;
	Matrix = *this;
	for(i = 0; i < 3; i++)
	{
		for(j = 0; j < 3; j++)
			m[i][j] = Matrix.m[i][0] * pMatrix->m[0][j] + Matrix.m[i][1] * pMatrix->m[1][j] + Matrix.m[i][2] * pMatrix->m[2][j];
	}
}

struct TRANSFORMMATRIXSSE2 : public TRANSFORMMATRIX
{
	FLOAT Unused[2];
	__forceinline void TransformFPU(FLOAT& px, FLOAT& py, LONG lx, LONG ly);
	__forceinline __m128 GetFactorOffsetYSSE2();
	__forceinline __m128 CalculateOffsetYSSE2(LONG ly);
	__forceinline __m128 TransformOffsetYSSE2(__m128 Factor, __m128 Offset, LONG lx);
	__forceinline TRANSFORMMATRIXSSE2 operator=(TRANSFORMMATRIX Matrix);
};

__forceinline void TRANSFORMMATRIXSSE2::TransformFPU(FLOAT& px, FLOAT& py, LONG lx, LONG ly)
{
	FLOAT x;
	FLOAT y;
	x = (FLOAT)lx;
	y = (FLOAT)ly;
	__asm
	{
		mov eax, this
		fld x
		fmul dword ptr [eax+24]
		fld y
		fmul dword ptr [eax+28]
		fadd dword ptr [eax+32]
		fadd
		fld st
		mov ecx, dword ptr [px]
		fld x
		fmul dword ptr [eax]
		fld y
		fmul dword ptr [eax+4]
		fadd dword ptr [eax+8]
		fadd
		fdivr
		fstp dword ptr [ecx]
		mov edx, dword ptr [py]
		fld x
		fmul dword ptr [eax+12]
		fld y
		fmul dword ptr [eax+16]
		fadd dword ptr [eax+20]
		fadd
		fdivr
		fstp dword ptr [edx]
	}
}

__forceinline __m128 TRANSFORMMATRIXSSE2::GetFactorOffsetYSSE2()
{
	return _mm_setr_ps(_11, _21, _31, _31);
}

__forceinline __m128 TRANSFORMMATRIXSSE2::CalculateOffsetYSSE2(LONG ly)
{
	__m128i i1;
	__m128 f1;
	__m128 f2;
	__m128 f3;
	i1 = _mm_setr_epi32(ly, 1, ly, 1);
	f1 = _mm_cvtepi32_ps(i1);
	f2 = _mm_loadu_ps(&_12);
	f3 = _mm_loadu_ps(&_22);
	f2 = _mm_shuffle_ps(f2, f3, _MM_SHUFFLE(1, 0, 1, 0));
	f3 = _mm_loadu_ps(&_32);
	f2 = _mm_mul_ps(f1, f2);
	f3 = _mm_mul_ps(f1, f3);
	f1 = _mm_shuffle_ps(f2, f2, _MM_SHUFFLE(2, 3, 0, 1));
	f2 = _mm_add_ps(f1, f2);
	f2 = _mm_shuffle_ps(f2, f2, _MM_SHUFFLE(3, 1, 2, 0));
	f1 = _mm_shuffle_ps(f3, f3, _MM_SHUFFLE(2, 3, 0, 1));
	f3 = _mm_add_ps(f1, f3);
	f1 = _mm_shuffle_ps(f2, f3, _MM_SHUFFLE(1, 0, 1, 0));
	return f1;
}

__forceinline __m128 TRANSFORMMATRIXSSE2::TransformOffsetYSSE2(__m128 Factor, __m128 Offset, LONG lx)
{
	__m128i i1;
	__m128 f1;
	__m128 f2;
	i1 = _mm_set1_epi32(lx);
	f1 = _mm_cvtepi32_ps(i1);
	f1 = _mm_mul_ps(f1, Factor);
	f1 = _mm_add_ps(f1, Offset);
	f2 = _mm_movehl_ps(f1, f1);
	f1 = _mm_div_ps(f1, f2);
	return f1;
}

__forceinline TRANSFORMMATRIXSSE2 TRANSFORMMATRIXSSE2::operator=(TRANSFORMMATRIX Matrix)
{
	*(TRANSFORMMATRIX*)this = Matrix;
	return *this;
}

//	ʂ̏\܂B
//	Effect͌ʂ̔ԍ܂B
//	HostVersion͑ΉVisual Clipper̃o[W܂B
//	EffectVersion͌ʂ̃o[W܂B
//	Flags͌ݎgpĂ܂B
//	Function͌ݎgpĂ܂B
//	Reserved͌ݎgpĂ܂B
//	Name͌ʂ̖O܂B
//	Copyright͌ʂ̒쌠܂B
//	Description͌ʂ̐܂B
//	NameACopyrightADescription̖̕[NULLłȂ΂Ȃ܂B
struct EFFECTINFO
{
	DWORD Effect;
	union
	{
		DWORD HostVersion;
		struct
		{
			WORD MinorHostVersion;
			WORD MajorHostVersion;
		};
	};
	union
	{
		DWORD EffectVersion;
		struct
		{
			WORD MinorEffectVersion;
			WORD MajorEffectVersion;
		};
	};
	DWORD Flags;
	void* Function;
	DWORD Reserved;
	WCHAR Name[64];
	WCHAR Copyright[64];
	WCHAR Description[256];
};

//	TransformEffectBlendModeɊi[l܂B
#define BLEND_MODE_DEFAULT					0
#define BLEND_MODE_AND						1
#define BLEND_MODE_OR						2
#define BLEND_MODE_XOR						3
#define BLEND_MODE_MULTIPLY					4
#define BLEND_MODE_ADD						5
#define BLEND_MODE_SUBTRACT					6
#define BLEND_MODE_INVALID					7

//	ȉ̊֐GNX|[gĂB
BOOL WINAPI DllMain(HANDLE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);
BOOL CALLBACK QueryEffect(DWORD Effect, EFFECTINFO* pEffectInfo);
DWORD CALLBACK EnumEffect(EFFECTINFO* pEffectInfo);
BOOL CALLBACK TransformEffect(DWORD Effect, void* pDestBits, DWORD DestPitch, DWORD DestHeight, RECT* pDestRect, RECT* pSrcRect, COLORREF Color, DWORD BlendMode, TRANSFORMMATRIX* pMatrix, TRANSFORMMATRIX* pInverse);

